#!/usr/bin/env bash

datadir="./data/"
dict="/usr/share/dict/words"
#wc -l $dict
[ -d "$datadir" ] || { echo "no ${datadir} directory."; exit; }

splitdict() { # 単語の長さ毎にファイルを分割 ... 長さの異なる語の比較は不要
    local n=({0..9}{0..9}) # 0leadさせたい。毎度printf呼ぶよりましか?
    echo "Splitting $dict"
    egrep -i '[lr]' $dict |
    while IFS= read -r ; do
        printf "%s\n" $REPLY >> $datadir${n[${#REPLY}]}
    done # <<<"$base"
}

set - ${datadir}[0-9][0-9]
if [ -f $1 ]; then
    echo $@
    read -p "Files exist: Skip / remove and [c]ontinue / [q]uit? "
    case $REPLY in
        [qQ]*) echo 'Quit'; exit ;;
        [cC]*)
            rm -f ${datadir}[0-9][0-9]
            splitdict
            ;;
        *) echo "Skip" ;;
    esac
else
    splitdict
fi

wc -l ${datadir}[0-9][0-9]
echo

[ -f ${datadir}result ] && echo "${datadi}result : exists"
read -p "Quit? " ; case $REPLY in [qyQY]*) echo 'Quit'; exit ;; esac

echo "start searching"
nl=$'\n'
for f in ${datadir}[0-9][0-9] ; do
    echo $f >&2
    fgrep -hi l $f | sed 's/l/[lr]/g;s/L/[LR]/g' |
    while read ; do
        #echo $REPLY
        ans=$(egrep -h "$REPLY" $f | sort | uniq)
        #[ $(wc -l <<<$ans) -gt 1 ] && echo $ans  ## 毎回wcを呼び出すのはコスト高
        [[ $ans =~ $nl ]] && echo $ans # 1単語しかみつからないならansは改行を含まない
    done
done | tee ${datadir}result  # teeを echo毎(直後)に実行、appendするのはコスト高

